#include <iostream>
#include <cmath>
#include <cassert>

bool is_prime(long long n) {
    if (n < 2) return false;
    for (long long i = 2; i * i <= n; ++i) {
        if (n % i == 0) return false;
    }
    return true;
}

int count_primes_in_range(long long a, long long b) {
    int count = 0;
    for (long long i = a; i <= b; ++i) {
        if (is_prime(i)) {
            ++count;
        }
    }
    return count;
}

int main() {
    int n;
    std::cin >> n;
    int sum = 0;
    while (n --) {
        long long a, b;
        std::cin >> a >> b;
        sum += (b - a + 1);
        assert(sum <= 1000);
        std::cout << count_primes_in_range(a, b) << "\n";
    }
    return 0;
}
