#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

const long long MAX_A_B = 1000000000000LL;
const int SMALL_MAX_A_B = 10000000;
const int MAX_N_SMALL = 10;
const int MAX_N_LARGE = 1000;
const long long SMALL_MAX_DIFF = 1000;
const long long MAX_TOTAL_DIFF = 10000000;

void generateTest(int n, long long minA, long long maxA, long long maxTotalDiff) {
    cout << n << endl;
    
    const auto sizes = rnd.partition(n, std::min(maxTotalDiff, maxA), (long long)1);

    for (int i = 0; i < n; i++) {
        long long a = rnd.next(minA, maxA - sizes[i] + 1);
        long long b = a + sizes[i] - 1;
        cout << a << " " << b << endl;
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int testCaseType = atoi(argv[1]);

    if (testCaseType == 1) {
        int n = rnd.next(1, MAX_N_SMALL);
        generateTest(n, 1, SMALL_MAX_A_B, MAX_TOTAL_DIFF);
    } else if (testCaseType == 2) {
        int n = rnd.next(1, MAX_N_LARGE);
        generateTest(n, 1, MAX_A_B, SMALL_MAX_DIFF);
    } else if (testCaseType == 3) {
        int n = rnd.next(1, MAX_N_LARGE);
        generateTest(n, 1, MAX_A_B, MAX_TOTAL_DIFF);
    } else {
        cerr << "Invalid test case type" << endl;
    }

    return 0;
}
